#%global perl_vendorlib %(eval $(perl -V:vendorlib); echo $vendorlib)
%global perl_vendorlib %{_libdir}/perl5/site_perl/5.10.0/
%global gitolite_homedir /var/lib/%{name}

Distribution:	CCux
Packager:	Karsten Brockmann <arcam@ccux-linux.de>	

Name:		gitolite
#Epoch:		0
Version:	2.0
Release:	1
License:	GNU/GPLv2
URL:		https://github.com/sitaramc/gitolite
Group:		Development/Other
Summary:	Highly flexible server for git directory version tracker
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildArch:	noarch

Provides:       perl(%{name}) = %{version}-%{release}

# Sources:
# The source for this package was pulled from upstream's vcs. 
# Use the following commands to generate the tarball:
# $ git clone git://github.com/sitaramc/gitolite.git gitolite
# $ cd gitolite
# $ git archive --prefix=gitolite-%{version}/ HEAD | bzip2 > ../gitolite-%{version}.tar.bz2
Source:		%{name}-%{version}.tar.bz2

# Patches:

# Requires:
Requires:	perl
Requires:	git
Requires:       openssh-clients

# BuildRequires:
BuildRequires:	perl
BuildRequires:  perl-Text-Markdown

%description
Gitolite allows a server to host many git repositories and provide access
to many developers, without having to give them real userids on the server.
The essential magic in doing this is ssh's pubkey access and the authorized
keys file, and the inspiration was an older program called gitosis.

Gitolite can restrict who can read from (clone/fetch) or write to (push) a
repository. It can also restrict who can push to what branch or tag, which
is very important in a corporate environment. Gitolite can be installed
without requiring root permissions, and with no additional software than git
itself and perl. It also has several other neat features described below and
elsewhere in the doc/ directory.


%pre
getent group %{name} >/dev/null || groupadd -r %{name}
getent passwd %{name} >/dev/null || \
useradd -r -g %{name} -d %{gitolite_homedir} -s /bin/sh \
        -c "git repository hosting" %{name}
exit 0

%preun

%post
if [ -f /sbin/ldconfig ]; then
    /sbin/ldconfig
fi

%postun
if [ -f /sbin/ldconfig ]; then
    /sbin/ldconfig
fi

%prep
%setup -q -n %{name}-%{version}

%build
#Drop gl-easy-install per upstream.
rm -f src/gl-easy-install

# Format documentation
for F in doc/*.mkd
do
        perl -MText::Markdown >$(echo $F |sed s/.mkd/.html/) <$F \
                -e 'print Text::Markdown::markdown (join "", <>)'
done

%install
rm -Rf $RPM_BUILD_ROOT

# Directory structure
install -d $RPM_BUILD_ROOT%{gitolite_homedir}
install -d $RPM_BUILD_ROOT%{gitolite_homedir}/.ssh
install -d $RPM_BUILD_ROOT%{_bindir}
install -d $RPM_BUILD_ROOT%{perl_vendorlib}
install -d $RPM_BUILD_ROOT%{_datadir}/%{name}

# Code
install -p src/gl-* $RPM_BUILD_ROOT%{_bindir}
install -p -m644 src/*.pm $RPM_BUILD_ROOT%{perl_vendorlib}
cp -a conf hooks $RPM_BUILD_ROOT%{_datadir}/%{name}

# empty authorized_keys file
touch $RPM_BUILD_ROOT%{gitolite_homedir}/.ssh/authorized_keys

%files
%defattr(-,root,root)
%{_bindir}/gl-auth-command
%{_bindir}/gl-compile-conf
%{_bindir}/gl-conf-convert
%{_bindir}/gl-dont-panic
%{_bindir}/gl-install
%{_bindir}/gl-mirror-shell
%{_bindir}/gl-mirror-sync
%{_bindir}/gl-query-rc
%{_bindir}/gl-setup
%{_bindir}/gl-setup-authkeys
%{_bindir}/gl-system-install
%{_bindir}/gl-time
%{_bindir}/gl-tool
%{_libdir}/perl5/site_perl/5.10.0/gitolite.pm
%{_libdir}/perl5/site_perl/5.10.0/gitolite_env.pm
%{_libdir}/perl5/site_perl/5.10.0/gitolite_rc.pm
%{_datadir}/gitolite
%{_localstatedir}/lib/gitolite

%clean
rm -Rf $RPM_BUILD_ROOT && rm -Rf $RPM_BUILD_DIR/%{name}-*

%changelog
* Thu Apr 28 2011 Karsten Brockmann <arcam@ccux-linux.de> 2.0-1
- initial CCux package release
- rc1
